# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b97"
os.chdir("/home/brettnak/.sage/sage_notebook/worksheets/admin/5/cells/54")
sage.server.notebook.interact.SAGE_CELL_ID=54
print _support_.syseval(html, ur'''<h3>A Deeper Exlaination</h3>
<p>Allow me to explain what it takes to setup a connection between two sensors (sensors may also be referred to as nodes).  Two nodes are connected to one another if and only if they share at least one in common.  Another way of stating this, is two are connected if and only if there is a key1 in node1\u0027s key ring and a key2 in node2\u0027s key ring such that key1 = key2.</p>

<p>This part is not illustrated in my code, but the first thing that each node does when it is initialized is a \u0027hello\u0027 broadcast in plain text.  This broadcast contains the the index of all the keys in that node\u0027s key ring. Now, once it is discovered which keys the two nodes share, those keys are hashed to produce a new encryption key that is actually used to send information securely.  Since you are reading this, I\u0027ll assume that you are familiar with a python list.  Imagine that each key ring, (k sub i) is setup as a dictionary, and the key pool, (P), is setup as a list. Then:</p>
<ul>
    <li>
        (P) can be thought of as:<br />
        [key(0), key(1), key(2), key(3) ...key(n)]
    </li>
    <li>
        and (k sub i) can be thought of as:<br />
        {keyindex(1):key(1), keyindex(2):key(2), .. . , keyindex(m):key(m)}<br />
     </li>
</ul>
Where
<ul>
    <li>m is the number of keys in each key ring</li>
    <li>n is the number of keys in the key pool</li>
    <li>keyindex(i) is the index of key(i) from the key pool.</li>
</ul>

Here is an example with:
<ul>
     <li>Key rings of size 2</li>
     <li>Key pool of size 4</li>
    <li>Sensor population 2</li>
</ul>
<ul>
    <li>Key Pool: [1kd03, 13e40, 1084d, 1340f]</li>
    <li>Key Ring 1: {3:1340f, 1:13e40}</li>
    <li>Key Ring 2: {0:1kd03, 3:1340f}</li>
</ul>
<br />
<h3>A Breakdown of Capturing a Sensor</h3>
<p>Because of the limited computational power of the devices and the fact that they are not meant to be completely secure due to their limited life span.  By that, I mean, if you imagine these devices in their actual setting, they will not be there for very long.  They are meant to be deployed in an adversarial environment.  We want to keep the adversary from knowing the communications of the network for a reasonable amount of time, but obviously, forever is not possible.</p>
<p>Imagine deploying this network in a setting where both friends and adversaries are present.  Now, these devices, depending on what type of sensor is actually attached to them, can be sending information, and probably would be, about what is going on overall in the environment.  Therefore, if these devices are spying on both friendly and adversarial activities, we would much prefer them to destroy the devices, rather than capturing them.  Therefore, we assume that the battery life has been calculated such that a device is more likely to run out of power before the enemy captures sufficient keys to spy on the traffic across the network</p>
<p>Again, because of limited power, the keys in the key ring of each device are not encrypted and therefore, capturing a sensor and reading all the keys off it\u0027s key ring is a trivial task.  Therefore, by capturing nodes in succession, an adversary can begin to build up a key pool of keys that are known to him.  The adversary can then spy on all traffic sent through a connection if and only if he knows <em>all</em> the keys that were used to hash that connection\u0027s encryption key</p>
<h3>How to Use the Interact</h3>
<p>capture_n: This will go through the each node and capture the node with the most secure connections, n times</p>
<p>add_n: This will add n sensors to the network.  Keep in mind, the connections added from these nodes are not necessarily secure.</p>
<p>capture_node:  This will capture the node with the corresponding number</p>
<p>Complete: This will show you the complete network, green links are secure, red links are compromised.</p>
<p>Secure: This will show you only the secure links</p>
<p>Compromised: This will show you only the compromised links</p>
<p><em>Important</em> You must reset the field you change to it\u0027s default value (0) before issuing another instruction, otherwise, only one of the instructions is run.</em>''', '/home/brettnak/.sage/sage_notebook/worksheets/admin/5/cells/54')

print "e97"
